#include <SPI.h>
#include <Wire.h>
#include <WiFi.h>
//=========OLED LIBRARIES==========================
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
//============MQTT CLIENT LIBRARIES================
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
//=================OLED SETTINGS====================

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET -1     // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

//=============WiFi Access Point===================

#define WLAN_SSID       "TECNO SPARK Go 2020"
#define WLAN_PASS       "@felicalon"
//==================================================

//===============ADAFRUIT SERVER SETUP =======

#define MQTT_SERVER "io.adafruit.com"
#define MQTT_PORT 1883
#define MQTT_USERNAME "felicalon"
#define MQTT_KEY "aio_yJLL11JJPvPxwBbEFXK8i3TalJpx"
WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, MQTT_SERVER, MQTT_PORT, MQTT_USERNAME, MQTT_KEY);
Adafruit_MQTT_Publish Sensor_data = Adafruit_MQTT_Publish(&mqtt, MQTT_USERNAME "/feeds/moisture" );


const int soilMoistureValue = 0;
const int SensorPin =36 ;
const int buttonPin = 14;
int soilmoisturepercent = 0;
int state = 0;
String Soil_state; 

void setup() {
  pinMode(buttonPin, INPUT_PULLUP);
  Serial.begin(115200); // open serial port, set the baud rate to 115200 bps
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // initialize with the I2C addr 0x3C (128x64)
  display.clearDisplay();
  //==================WIFI CONNECTION =======
  
   WiFi.begin(WLAN_SSID , WLAN_PASS );
  display.clearDisplay();
  display.setCursor(20,20);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Booting");
  display.display();  
  delay(3000);
  
}

void loop() {
  int soilMoistureValue = analogRead(SensorPin); // put Sensor insert into soil
  Serial.println(soilMoistureValue);
 soilmoisturepercent = map(soilMoistureValue, 2555, 30, 100, 0);

  if( soilmoisturepercent <5){
     Soil_state ="DRY!!";
    //display dry in lcd 
    display_dry();
    }
    if( soilmoisturepercent > 5  && soilmoisturepercent <35 ){
    
     Soil_state ="Medium";
     display_medium();
    }
    
    if( soilmoisturepercent>35 ){
    Soil_state ="WET" ;
    display_wet();
    }
  
  if (digitalRead(buttonPin) == LOW) {
    state = 1;
    Serial.println("HOLD");
   // data_display();
  delay(5000);
  chechwifi();

  }

}
 void display_dry(){
  display.clearDisplay();
  display.setCursor(10, 0);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Soil");
  
  display.setCursor(55,0 );
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Moisture");
  
  display.setCursor(30, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(soilmoisturepercent);
   display.setCursor(50, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(" %");
 //DISPLAY SOIL STATUS 
  display.setCursor(20,50);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println(Soil_state);
  display.display();
  
  }

  void display_medium(){
    display.clearDisplay();
  display.setCursor(10, 0);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Soil");
  
  display.setCursor(55,0 );
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Moisture");
  
  display.setCursor(30, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(soilmoisturepercent);
   display.setCursor(50, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(" %");
 //DISPLAY SOIL STATUS 
  display.setCursor(20,50);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println(Soil_state);
  display.display();
    }
    void display_wet(){
          display.clearDisplay();
  display.setCursor(10, 0);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Soil");
  
  display.setCursor(55,0 );
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Moisture");
  
  display.setCursor(30, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(soilmoisturepercent);
   display.setCursor(50, 20);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(" %");
 //DISPLAY SOIL STATUS 
  display.setCursor(20,50);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println(Soil_state);
  display.display();
  }

  void MQTT_connect() {
  int8_t ret;

  // Stop if already connected.
  if (mqtt.connected()) {
    return;
  }

  Serial.print("Connecting to MQTT... ");
  display.clearDisplay();
  display.setCursor(0, 20);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Connecting");
   display.setCursor(40, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("To mqtt");
  display.display();
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) { // connect will return 0 for connected
       Serial.println(mqtt.connectErrorString(ret));
       
  Serial.println("Retrying MQTT connection in 5 seconds...");
  display.clearDisplay();
  display.setCursor(50, 20);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Retrying...");
  display.display();
       mqtt.disconnect();
       delay(5000);  // wait 5 seconds
       retries--;
       if (retries == 0) {
         // basically die and wait for WDT to reset me
         while (1);
       }
  }
  Serial.println("MQTT Connected!");
  display.clearDisplay();
  display.setCursor(0, 20);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("MQTT");
  display.setCursor(50, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Connected");
  display.display();
  delay(2000);
}

void  chechwifi(){
  int retries = 0;
  while (WiFi.status() != WL_CONNECTED && retries < 50 )
  {
  
  Serial.print("."); 
  delay(100);
  display.clearDisplay();
  display.setCursor(5, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Connecting ");
  display.setCursor(70, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println(" to  wifi....");
  display.display();  
  retries++;      
  }
  if (WiFi.status() == WL_CONNECTED) {
    Serial.println();
    Serial.print("Wi-Fi connected. IP address: ");
    Serial.println(WiFi.localIP());
  display.clearDisplay();
  display.setCursor(0,20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("WiFi");
  display.setCursor(40, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("CONNECTED");
  display.display();
  delay(2000);
  MQTT_connect();
    display.clearDisplay();
  display.setCursor(0, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("sending to the server");
  display.display();
  delay(3000);
  if (! Sensor_data.publish(soilmoisturepercent)) {
      Serial.println(F("Failed"));

  display.clearDisplay();
  display.setCursor(50, 20);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("Failed to send ");
  display.display();
  delay(3000);
    } else {
      Serial.println(F("OK!"));
  display.clearDisplay();
  display.setCursor(20, 20);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Data sent ");
  display.display();
  delay(3000);
    }
  } else {
    Serial.println();
    Serial.println("Wi-Fi connection failed. Continuing without Wi-Fi.");
    display.clearDisplay();
  display.setCursor(0,0);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("NO WIFI...");
  display.display();
  delay(2000); 
  }
   

  }
