#include <WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#include <Adafruit_SSD1306.h>

const char* ssid = "TECNO SPARK Go 2020";
const char* password = "$felicalon";

#define AIO_SERVER      "io.adafruit.com"
#define AIO_SERVERPORT  1883
#define AIO_USERNAME    "felicalon"
#define AIO_KEY         "aio_yJLL11JJPvPxwBbEFXK8i3TalJpx"

WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);

Adafruit_MQTT_Publish feed = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/moisture");
const int moisturePin = 21;
const int moistureThreshold = 50;

#define OLED_RESET     -1
Adafruit_SSD1306 display(OLED_RESET);

void setup() {
    Serial.begin(115200);

    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }
    Serial.println("WiFi connected");

    mqtt.connect();
    while (!mqtt.connected()) {
        Serial.print(".");
        delay(1000);
    }
    Serial.println("MQTT connected");

    display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
    display.display();
    delay(2000);
    display.clearDisplay();
}

void loop() {
    int moistureValue = analogRead(moisturePin);

    // Display moisture value on OLED
    display.clearDisplay();
    display.setTextSize(2);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.println("Moisture:");
    display.setCursor(0, 12);
    display.println(moistureValue);
    display.display();

    // Check moisture threshold and send notification
    if (moistureValue > moistureThreshold) {
        feed.publish("Moisture threshold exceeded!");
    }

    delay(1000);
}
