#include <WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#include <Adafruit_SSD1306.h>

const char* ssid = "TECNO SPARK Go 2020";
const char* password = "@felicalon";

#define AIO_SERVER      "io.adafruit.com"
#define AIO_SERVERPORT  1883
#define AIO_USERNAME    "felicalon"
#define AIO_KEY         "aio_yJLL11JJPvPxwBbEFXK8i3TalJpx"

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);

Adafruit_MQTT_Publish feed = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/moisture");

const int AirValue = 3620;   // Replace this value with the air value from your sensor
const int WaterValue = 1680;  // Replace this value with the water value from your sensor
const int SensorPin = 15;
const int moistureThreshold = 50;
int soilMoistureValue = 0;
int soilmoisturepercent = 0;

void setup() {
  Serial.begin(115200);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();

  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("WiFi connected");

  mqtt.connect();
  while (!mqtt.connected()) {
    Serial.print(".");
    delay(1000);
  }
  Serial.println("MQTT connected");
}

void loop() {
  soilMoistureValue = analogRead(SensorPin);
  soilmoisturepercent = map(soilMoistureValue, AirValue, WaterValue, 0, 100);

  if (soilmoisturepercent > 100) {
    Serial.println("100 %");
    displayValue("100 %");
  }
  else if (soilmoisturepercent < 0) {
    Serial.println("0 %");
    displayValue("0 %");
  }
  else if (soilmoisturepercent >= 0 && soilmoisturepercent <= 100) {
    Serial.print(soilmoisturepercent);
    Serial.println(" %");
    displayValue(String(soilmoisturepercent) + " %");
  }

  // Check moisture threshold and send notification
  if (soilmoisturepercent > moistureThreshold) {
    feed.publish(soilmoisturepercent);
  }

  delay(4000);
}

void displayValue(String value) {
  display.clearDisplay();
  display.setCursor(45, 0);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Soil");
  display.setCursor(20, 15);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Moisture is");
  display.setCursor(30, 40);
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(value);
  display.display();
}
