#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
 
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
 
const int soilMoistureValue=0;

const int SensorPin = 15;
const int buttonPin=14 ;   
int soilMoistureValue = 0;
int soilmoisturepercent=0;
int state=0;

 
 
void setup() {
  pinMode(buttonPin,INPUT_PULLUP);
  Serial.begin(115200); // open serial port, set the baud rate to 9600 bps
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); //initialize with the I2C addr 0x3C (128x64)
  display.clearDisplay();
}
 
 
void loop() 
{
  soilMoistureValue = analogRead(SensorPin);  //put Sensor insert into soil
Serial.println(soilMoistureValue);
soilmoisturepercent = map(soilMoistureValue, 2555, 30, 100,0);
if(digitalRead(buttonPin)== LOW){
  state=1;
 
    Serial.println("HOLD");
    data_display();
    delay(5000);
}
  if(state == 1){
     send_data();
  }
  data_display(); 

}

void measure_hold(){

}
void data_display(){
 Serial.println("100 %");
  
  display.setCursor(45,0);  //oled display
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Soil");
  display.setCursor(20,15);  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("Moisture is");
  
  display.setCursor(30,40);  //oled display
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.println(soilmoisturepercent);
  display.display();
  delay(250);
  display.clearDisplay();
}
void send_data(){
  delay(3000);
    display.setCursor(45,0);  //oled display
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.println("DATA SENT");
}
